Attribute VB_Name = "Module1"
Option Explicit
 ' You may use and modify this code for your personal use only.
 ' You may also redistribute this code providing that
 ' a) No fee is charged 
 ' b) This copyright notice is retained in the source code.
 '
 ' You may not use this code for commercial purposes
 ' without the express permission of the copyright holder
 '
 ' Copyright (c) 2006 Dermot Hogan 
 '
 '
Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" _
(ByVal lpPrevWndFunc As Long, _
ByVal hwnd As Long, ByVal Msg As Long, _
ByVal wParam As Long, ByVal lParam As Long) As Long

Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)

Private Declare Function BeginPaint Lib "user32" (ByVal hwnd As Long, lpPaint As PAINTSTRUCT) As Long
Private Declare Function EndPaint Lib "user32" (ByVal hwnd As Long, lpPaint As PAINTSTRUCT) As Long
Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function RectangleX Lib "gdi32" Alias "Rectangle" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function InvalidateRect Lib "user32" (ByVal hwnd As Long, lpRect As Any, ByVal bErase As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function SetViewportExtEx Lib "gdi32" (ByVal hdc As Long, ByVal nX As Long, ByVal nY As Long, lpSize As Any) As Long
Private Declare Function SetWindowExtEx Lib "gdi32" (ByVal hdc As Long, ByVal nX As Long, ByVal nY As Long, lpSize As Size) As Long
Private Declare Function SetWindowOrgEx Lib "gdi32" (ByVal hdc As Long, ByVal nX As Long, ByVal nY As Long, lpPoint As Any) As Long
Private Declare Function SetViewportOrgEx Lib "gdi32" (ByVal hdc As Long, ByVal nX As Long, ByVal nY As Long, lpPoint As Any) As Long
Private Declare Function ClientToScreen Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Private Declare Function SetMapMode Lib "gdi32" (ByVal hdc As Long, ByVal nMapMode As Long) As Long
         
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
(ByVal hwnd As Long, ByVal nIndex As Long, _
ByVal dwNewLong As Long) As Long

Private Type POINTAPI
        x As Long
        y As Long
End Type
Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type
Private Type PAINTSTRUCT
        hdc As Long
        fErase As Long
        rcPaint As RECT
        fRestore As Long
        fIncUpdate As Long
        rgbReserved(32) As Byte
End Type
Private Type Size
        cx As Long
        cy As Long
End Type

Const GWL_WNDPROC = (-4)

Const WM_MOUSEMOVE = &H200
Const WM_MOUSEACTIVATE = &H21
Const WM_LBUTTONDBLCLK = &H203
Const WM_LBUTTONDOWN = &H201
Const WM_LBUTTONUP = &H202
Const WM_KEYDOWN = &H100
Const WM_KEYUP = &H101
Const WM_RBUTTONDOWN = &H204
Const WM_RBUTTONUP = &H205
Const WM_NOTIFY = &H4E
Private Const WM_SIZE = &H5
Private Const PS_SOLID = 0
Private Const WM_PAINT = &HF
Private Const WM_ERASEBKGND = &H14
Private Const MM_ISOTROPIC = 7

Private oldproc As Long

Public Sub zap(h As Long)

If oldproc = 0 Then
    oldproc = SetWindowLong(h, GWL_WNDPROC, AddressOf MyWndProc)
Else
    MsgBox "Window is already subclassed!"
End If

End Sub

Public Sub unzap(h As Long)

If oldproc <> 0 Then
    SetWindowLong h, GWL_WNDPROC, oldproc
    oldproc = 0
Else
    MsgBox "Window was not subclassed!"
End If
    
End Sub
Private Function MyWndProc(ByVal hwnd As Long, _
ByVal iMsg As Long, _
ByVal wParam As Long, _
ByVal lParam As Long) As Long
Dim ps As PAINTSTRUCT, hdc As Long
Dim brush As Long, rc As RECT, r As Long
Dim height As Long, width As Long

Select Case iMsg
Case WM_PAINT
    hdc = BeginPaint(hwnd, ps)
    Debug.Print "WM_PAINT(1):" & ps.fErase & ":" & ps.rcPaint.Bottom & ":" & ps.rcPaint.Left & ":" & ps.rcPaint.Right & ":" & ps.rcPaint.Top
    DrawBox hdc
    EndPaint hwnd, ps
    MyWndProc = 0
Case WM_ERASEBKGND
    GetClientRect hwnd, rc
    Debug.Print "WM_ERASEBKGND:" & rc.Bottom & ":" & rc.Left&; ":" & rc.Right & ":" & rc.Top
    brush = CreateSolidBrush(vbGreen)
    FillRect wParam, rc, brush
    MyWndProc = 0
Case WM_SIZE
    width = lParam And &H3FFF
    height = lParam \ 65536
    Debug.Print "WM_SIZE:" & height & ":" & width
    MyWndProc = 0
Case Else
    MyWndProc = CallWindowProc(oldproc, hwnd, iMsg, wParam, lParam)
End Select

End Function
Public Sub DrawBox(hdc As Long)
Dim pen As Long
Dim brush As Long

If Form1.activeFlag Then
    pen = CreatePen(PS_SOLID, 15, vbCyan)
    DeleteObject SelectObject(hdc, pen)
    brush = CreateSolidBrush(vbBlue)
    DeleteObject SelectObject(hdc, brush)
    RectangleX hdc, 5, 5, 200, 100
End If

End Sub


Public Sub DoBackGround(hwnd As Long, hdc As Long)
Dim brush As Long, rc As RECT, r As Long
    
GetClientRect hwnd, rc
brush = CreateSolidBrush(vbGreen)
FillRect hdc, rc, brush

End Sub

